<template>
	<section :id="id" :aria-label="heading ? null : 'Testimonials'" class="u-block-spacing" :class="$style.block">
		<h2 v-if="heading" class="u-heading u-heading--pre-line" :class="$style.heading">{{ heading }}</h2>

		<div v-if="featured" role="group" aria-label="Featured testimonial" :class="[$style.desktop, $style.featured]">
			<BaseImage
				:image="featured.testimonialImageMobile"
				:images="{ medium: featured.testimonialImage }"
				compression-level="medium"
				fit
				sizes="calc(100vw - 144px)"
			/>

			<h2
				v-if="featured.testimonialQuote"
				class="u-heading"
				:class="$style.featuredQuote"
				:style="{ color: featured.copyColor }"
			>
				“{{ featured.testimonialQuote }}”
			</h2>

			<p
				v-if="featured.testimonialName"
				class="u-subheading"
				:class="$style.featuredName"
				:style="{ color: featured.copyColor }"
			>
				— {{ featured.testimonialName }}
			</p>

			<button
				v-if="featured.testimonialVideoModal"
				type="button"
				:class="$style.playButton"
				aria-label="Play video"
				@click="open(featured)"
			>
				<BaseIcon name="play" title="Play Video" width="24" height="24" />
			</button>
		</div>

		<MoleculeCarousel
			:autoplay="false"
			:has-navigation="false"
			:class="$style.carousel"
			:has-pagination="slides.length > 1"
		>
			<MoleculeCarouselSlide
				v-for="(slide, slideIndex) in slides"
				:key="slideIndex"
				:slide-index="slideIndex"
				:class="$style.slide"
			>
				<div
					v-for="(testimonial, testimonialIndex) in slide"
					:key="testimonialIndex"
					role="group"
					aria-label="Testimonial video"
					:class="$style.testimonial"
				>
					<div v-if="testimonial.testimonialImage && testimonial.testimonialImage.url" :class="$style.testimonialImage">
						<BaseImage
							:image="testimonial.testimonialImageMobile"
							:images="{ medium: testimonial.testimonialImage }"
							compression-level="medium"
							:params="{ cs: 'strip' }"
							fit
							sizes="(min-width: 1024px) calc((100vw - 120px) * 0.34), 100vw"
						/>

						<button
							v-if="testimonial.testimonialVideoModal"
							type="button"
							:class="[$style.playButton, $style.testimonialPlay]"
							aria-label="Play video"
							@click="open(testimonial)"
						>
							<BaseIcon name="play" title="Play Video" width="24" height="24" />
						</button>
					</div>

					<h3 v-if="testimonial.testimonialHeading" class="u-font-secondary" :class="$style.testimonialHeading">
						{{ testimonial.testimonialHeading }}
					</h3>

					<p v-if="testimonial.testimonialName" :class="$style.testimonialName">
						— {{ testimonial.testimonialName }}
					</p>
				</div>
			</MoleculeCarouselSlide>
		</MoleculeCarousel>

		<GlobalModal
			v-if="videoModal && isModalOpen"
			appearance="video"
			:video="videoModal.html"
			:video-tracking-name="videoModalTrackingName"
			@close="close"
		/>
	</section>
</template>

<script>
import MoleculeCarousel from '@components/molecule-carousel';
import MoleculeCarouselSlide from '@components/molecule-carousel-slide';
import GlobalModal from '@components/global-modal';
import debounce from 'lodash/debounce';
import { chunkArray } from '@/utils';

export default {
	components: {
		MoleculeCarousel,
		MoleculeCarouselSlide,
		GlobalModal,
	},

	props: {
		id: {
			type: String,
			default: null,
		},

		heading: {
			type: String,
			default: '',
		},

		featured: {
			type: Object,
			default: () => ({}),
		},

		testimonials: {
			type: Array,
			default: () => [],
		},
	},

	data() {
		return {
			videoModal: null,
			videoModalTrackingName: '',
			isModalOpen: false,
			windowWidth: 0,
			debouncedResize: debounce(this.handleResize, 100),
		};
	},

	computed: {
		slides() {
			const { windowWidth, featured, testimonials } = this;

			if (windowWidth < this.$style.breakpoint) {
				// add featured to the slides for mobile
				return chunkArray([featured, ...testimonials], 1);
			}

			return chunkArray(testimonials, 3);
		},
	},

	mounted() {
		this.windowWidth = window.innerWidth;
		window.addEventListener('resize', this.debouncedResize);
	},

	destroyed() {
		window.removeEventListener('resize', this.debouncedResize);
	},

	methods: {
		handleResize() {
			this.windowWidth = window.innerWidth;
		},

		open(video) {
			this.videoModal = video.testimonialVideoModal;
			this.videoModalTrackingName = `Testimonials${video.heading ? ' - Main' : ''} - ${video.testimonialHeading} - ${
				video.testimonialName
			}`;
			this.isModalOpen = true;
		},

		close() {
			this.isModalOpen = false;
			this.videoModal = '';
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.block {
	overflow: hidden;
}

.heading {
	padding: 0 size('s');
}

.featured {
	position: relative;
	display: flex;
	flex-direction: column;
	align-items: center;
	justify-content: center;
	height: 64rem;
	padding: 0 size('s');
	color: color('white');
	text-align: center;
	background-color: color('black');
}

.featuredQuote {
	z-index: 1;
	max-width: 80rem;
	margin-bottom: size('m');
	line-height: 1.3;
}

.featuredName {
	z-index: 1;
	margin-top: size('s') - size('m');
	margin-bottom: size('m');
	color: inherit;
}

.playButton {
	z-index: 1;
	width: 5rem;
	height: 5rem;
	background-color: color('white');
	border-radius: 50%;
}

// Carousel
.carousel {
	@include above('large') {
		margin: 0 size('l') * -0.5;
	}
}

.slide {
	display: flex;
}

.testimonial {
	flex: 1 1 auto;
	text-align: center;

	@include above('large') {
		width: (100% / 3);
		margin: 0 size('l') * 0.5;
	}
}

.testimonialImage {
	position: relative;
	width: 100%;
	height: 0;
	padding-bottom: 56.25%;
	margin-bottom: size('m');
	overflow: hidden;
}

.testimonialPlay {
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
}

.testimonialHeading {
	margin-bottom: size('xxs');
	font-size: 2.2rem;
}

.testimonialName {
	color: color('primary-100');

	@include use-text-style('type');
	@include use-text-style('type-200');
}

.mobile {
	@include above('large') {
		display: none;
	}
}

.desktop {
	@include below('large') {
		display: none;
	}
}

:export {
	/* stylelint-disable-next-line property-no-unknown */
	breakpoint: 1024;
}
</style>
